<template>
  <div id="Sidebar">
    <el-row class="sidebar">
      <el-col :span="24" class="main">
        <el-col :span="24" class="one">
          <el-menu
            class="sidebar-el-menu"
            :default-active="onRoutes"
            :collapse="collapse"
            background-color="#324157"
            text-color="#bfcbd9"
            active-text-color="#20a0ff"
            unique-opened
            router
          >
            <template v-for="item in items">
              <template v-if="item.subs">
                <el-submenu :index="item.index" :key="item.index">
                  <template slot="title">
                    <i :class="['iconfont', item.icon]"></i>
                    <span slot="title">{{ item.title }}</span>
                  </template>
                  <template v-for="subItem in item.subs">
                    <el-submenu v-if="subItem.subs" :index="subItem.index" :key="subItem.index">
                      <template slot="title">{{ subItem.title }}</template>
                      <el-menu-item v-for="(threeItem, i) in subItem.subs" :key="i" :index="threeItem.index">{{ threeItem.title }}</el-menu-item>
                    </el-submenu>
                    <el-menu-item v-else :index="subItem.index" :key="subItem.index">{{ subItem.title }}</el-menu-item>
                  </template>
                </el-submenu>
              </template>
              <template v-else>
                <el-menu-item class="first" :index="item.index" :key="item.index">
                  <i :class="['iconfont', item.icon]"></i>
                  <span slot="title">{{ item.title }}</span>
                </el-menu-item>
              </template>
            </template>
          </el-menu>
        </el-col>
      </el-col>
    </el-row>
  </div>
</template>

<script>
const { system, userMenu } = require('../../layout/deploy/menu');
import { mapState, createNamespacedHelpers } from 'vuex';
import _ from 'lodash';
import bus from './bus';
export default {
  name: 'Sidebar',
  props: {},
  components: {},
  data: function() {
    return {
      collapse: false,
      items: system,
    };
  },
  created() {
    bus.$on('collapse', msg => {
      this.collapse = msg;
      bus.$emit('collapse-content', msg);
    });
  },
  methods: {
    getMenu() {
      let list = _.cloneDeep(this.items);
      list.push(...userMenu);
      this.$set(this, `items`, _.uniqBy(list, 'index'));
    },
  },
  computed: {
    ...mapState(['user']),
    onRoutes() {
      return this.$route.path.replace('/', '');
    },
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
  watch: {
    user: {
      deep: true,
      immediate: true,
      handler(val) {
        this.getMenu();
      },
    },
  },
};
</script>

<style lang="less" scoped>
.sidebar {
  display: block;
  position: absolute;
  left: 0;
  top: 60px;
  bottom: 0;
  overflow-y: scroll;
  background-color: rgb(50, 65, 87);
}
.sidebar::-webkit-scrollbar {
  width: 0;
}
.sidebar-el-menu:not(.el-menu--collapse) {
  width: 200px;
}
.sidebar > ul {
  height: 100%;
}
.main {
  .one {
    .iconfont {
      font-size: 18px;
      margin: 0 5px 0 0;
    }
  }
}
</style>
